﻿'Programed by NAS6
'参考文献
'天体の位置計算増補版　長沢工　地人書館
'理科年表平成8年1996年　国立天文台　丸善
'理科年表平成25年2013年　国立天文台　丸善
'実習占星学入門　石川源晃　平河出版社


Public Class Form1
    Public CNST_DR As Double = 0.017453292519943

    Private planet(,) As Planet

    Private dat1 As New DateTime(2000, 1, 1, 0, 0, 0)
    Private longitude1 As Double
    Private dat2 As New DateTime(2000, 1, 1, 0, 0, 0)
    Private longitude2 As Double
    Private chart As Boolean

    Private dt As Double = 0.0
    Private time As Double = 0.0


    Private bitmap As Bitmap
    Private tip() As Bitmap

    Private asp(,,) As Integer
    Private asp2(,) As Integer

    Private aasp(,) As Double
    Private brs() As System.Drawing.Brush
    Private mean() As Mean


    Private Sub Application_ApplicationExit(ByVal sender As Object, ByVal e As EventArgs)
        'ApplicationExitイベントハンドラを削除
        RemoveHandler Application.ApplicationExit, AddressOf Application_ApplicationExit
    End Sub

    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        'ApplicationExitイベントハンドラを追加
        AddHandler Application.ApplicationExit, AddressOf Application_ApplicationExit

        'チップ読み込み
        ReDim tip(42)

        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\sun.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(0) = bmpSrc
        Catch ex As Exception
            tip(0) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\sun.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(1) = bmpSrc
        Catch ex As Exception
            tip(1) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\moon.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(2) = bmpSrc
        Catch ex As Exception
            tip(2) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\mercury.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(3) = bmpSrc
        Catch ex As Exception
            tip(3) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\venus.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(4) = bmpSrc
        Catch ex As Exception
            tip(4) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\mars.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(5) = bmpSrc
        Catch ex As Exception
            tip(5) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\jupiter.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(6) = bmpSrc
        Catch ex As Exception
            tip(6) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\saturn.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(7) = bmpSrc
        Catch ex As Exception
            tip(7) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\uranus.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(8) = bmpSrc
        Catch ex As Exception
            tip(8) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\neptune.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(9) = bmpSrc
        Catch ex As Exception
            tip(9) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\pluto.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(10) = bmpSrc
        Catch ex As Exception
            tip(10) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\ceres.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(11) = bmpSrc
        Catch ex As Exception
            tip(11) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\pallas.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(12) = bmpSrc
        Catch ex As Exception
            tip(12) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\juno.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(13) = bmpSrc
        Catch ex As Exception
            tip(13) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\vesta.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(14) = bmpSrc
        Catch ex As Exception
            tip(14) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\chiron.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(15) = bmpSrc
        Catch ex As Exception
            tip(15) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\lilith.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(16) = bmpSrc
        Catch ex As Exception
            tip(16) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\dragonhead.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(17) = bmpSrc
        Catch ex As Exception
            tip(17) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\dragontail.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(18) = bmpSrc
        Catch ex As Exception
            tip(18) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\asc.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(19) = bmpSrc
        Catch ex As Exception
            tip(19) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\mc.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(20) = bmpSrc
        Catch ex As Exception
            tip(20) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\aries.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(21) = bmpSrc
        Catch ex As Exception
            tip(21) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\taurus.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(22) = bmpSrc
        Catch ex As Exception
            tip(22) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\gemini.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(23) = bmpSrc
        Catch ex As Exception
            tip(23) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\cancer.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(24) = bmpSrc
        Catch ex As Exception
            tip(24) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\leo.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(25) = bmpSrc
        Catch ex As Exception
            tip(25) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\virgo.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(26) = bmpSrc
        Catch ex As Exception
            tip(26) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\libra.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(27) = bmpSrc
        Catch ex As Exception
            tip(27) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\scorpio.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(28) = bmpSrc
        Catch ex As Exception
            tip(28) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\sagittarius.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(29) = bmpSrc
        Catch ex As Exception
            tip(29) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\capricorn.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(30) = bmpSrc
        Catch ex As Exception
            tip(30) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\aquarius.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(31) = bmpSrc
        Catch ex As Exception
            tip(31) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\pisces.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(32) = bmpSrc
        Catch ex As Exception
            tip(32) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\conjunction.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(33) = bmpSrc
        Catch ex As Exception
            tip(33) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\sextile.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(34) = bmpSrc
        Catch ex As Exception
            tip(34) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\square.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(35) = bmpSrc
        Catch ex As Exception
            tip(35) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\trine.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(36) = bmpSrc
        Catch ex As Exception
            tip(36) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\opposition.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(37) = bmpSrc
        Catch ex As Exception
            tip(37) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\semisextile.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(38) = bmpSrc
        Catch ex As Exception
            tip(38) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\semisquare.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(39) = bmpSrc
        Catch ex As Exception
            tip(39) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\quintile.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(40) = bmpSrc
        Catch ex As Exception
            tip(40) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\biquintile.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(41) = bmpSrc
        Catch ex As Exception
            tip(41) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try
        Try
            Dim fs2 As System.IO.FileStream
            fs2 = New System.IO.FileStream("res\\quincunx.bmp", System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim bmpSrc As Bitmap = System.Drawing.Bitmap.FromStream(fs2)
            fs2.Close()
            tip(42) = bmpSrc
        Catch ex As Exception
            tip(42) = New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        End Try

        ReDim brs(21)


        'ブラシ初期化
        brs(0) = Brushes.Black
        brs(1) = Brushes.White
        brs(2) = Brushes.LemonChiffon
        brs(3) = Brushes.Yellow
        brs(4) = Brushes.LightPink
        brs(5) = Brushes.DeepPink
        brs(6) = Brushes.LightBlue
        brs(7) = Brushes.Blue
        brs(8) = Brushes.LightPink
        brs(9) = Brushes.DeepPink
        brs(10) = Brushes.LightBlue
        brs(11) = Brushes.Blue
        brs(12) = Brushes.LightPink
        brs(13) = Brushes.DeepPink
        brs(14) = Brushes.LightBlue
        brs(15) = Brushes.Blue
        brs(16) = Brushes.LightGreen
        brs(17) = Brushes.Green
        brs(18) = Brushes.LightGreen
        brs(19) = Brushes.Green
        brs(20) = Brushes.LemonChiffon
        brs(21) = Brushes.Yellow


        'アスペクトテーブル初期化
        ReDim aasp(1, 9)
        aasp(0, 0) = 0.0 'conjunction
        aasp(0, 1) = 60.0 'sextile
        aasp(0, 2) = 90.0 'square
        aasp(0, 3) = 120.0 'trine
        aasp(0, 4) = 180.0 'opposition
        aasp(0, 5) = 30.0 'semisextile
        aasp(0, 6) = 45.0 'semisquare
        aasp(0, 7) = 72.0 'quintile
        aasp(0, 8) = 144.0 'biquintile
        aasp(0, 9) = 150.0 'quincunx
        aasp(1, 0) = 5.0
        aasp(1, 1) = 5.0
        aasp(1, 2) = 5.0
        aasp(1, 3) = 5.0
        aasp(1, 4) = 5.0
        aasp(1, 5) = 2.5
        aasp(1, 6) = 2.5
        aasp(1, 7) = 2.5
        aasp(1, 8) = 2.5
        aasp(1, 9) = 2.5


        'キーワードテーブル初期化
        ReDim mean(30)

        Dim name As String
        Dim base As String
        Dim thing As String
        Dim body As String
        Dim depend(2) As Integer
        Dim deacon(2) As Integer
        Dim word(1, 11) As String

        name = "地球"
        base = ""
        thing = ""
        body = ""
        word(0, 0) = ""
        word(0, 1) = ""
        word(0, 2) = ""
        word(0, 3) = ""
        word(0, 4) = ""
        word(0, 5) = ""
        word(0, 6) = ""
        word(0, 7) = ""
        word(0, 8) = ""
        word(0, 9) = ""
        word(0, 10) = ""
        word(0, 11) = ""
        word(1, 0) = ""
        word(1, 1) = ""
        word(1, 2) = ""
        word(1, 3) = ""
        word(1, 4) = ""
        word(1, 5) = ""
        word(1, 6) = ""
        word(1, 7) = ""
        word(1, 8) = ""
        word(1, 9) = ""
        word(1, 10) = ""
        word(1, 11) = ""
        mean(0) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "太陽"
        base = "生命の与え主"
        thing = "政府,父親,主人,夫,男性"
        body = ""
        word(0, 0) = "積極的"
        word(0, 1) = "保守的"
        word(0, 2) = "知能的"
        word(0, 3) = "内向的"
        word(0, 4) = "楽天的"
        word(0, 5) = "批判的"
        word(0, 6) = "協調的"
        word(0, 7) = "情熱的"
        word(0, 8) = "外交的"
        word(0, 9) = "権威的"
        word(0, 10) = "革新的"
        word(0, 11) = "神秘的"
        word(1, 0) = "活力"
        word(1, 1) = "財力"
        word(1, 2) = "筆力"
        word(1, 3) = "家庭"
        word(1, 4) = "恋愛"
        word(1, 5) = "奉仕"
        word(1, 6) = "協調"
        word(1, 7) = "他力"
        word(1, 8) = "信仰"
        word(1, 9) = "責任"
        word(1, 10) = "社交"
        word(1, 11) = "隠居"
        mean(1) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "月"
        base = "感受性"
        thing = "母親,妻,女性"
        body = ""
        word(0, 0) = "猛進的"
        word(0, 1) = "保身的"
        word(0, 2) = "直感的"
        word(0, 3) = "情緒不安定"
        word(0, 4) = "包容力の欠如"
        word(0, 5) = "知性的"
        word(0, 6) = "限定的"
        word(0, 7) = "策謀的"
        word(0, 8) = "一方的"
        word(0, 9) = "自主的"
        word(0, 10) = "慇懃,体裁屋"
        word(0, 11) = "浪漫的"
        word(1, 0) = "空想"
        word(1, 1) = "出費"
        word(1, 2) = "調査"
        word(1, 3) = "家屋"
        word(1, 4) = "移気"
        word(1, 5) = "弱気"
        word(1, 6) = "普遍"
        word(1, 7) = "相続"
        word(1, 8) = "旅行"
        word(1, 9) = "変動"
        word(1, 10) = "社交"
        word(1, 11) = "孤独"
        mean(2) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "水星"
        base = "流動性"
        thing = "通信,交通,商売,旅行,兄弟"
        body = ""
        word(0, 0) = "商才"
        word(0, 1) = "現世的なこと"
        word(0, 2) = "霊能,文筆"
        word(0, 3) = "学芸全般"
        word(0, 4) = "顕示的なこと"
        word(0, 5) = "実務的なこと"
        word(0, 6) = "知的,音楽的"
        word(0, 7) = "霊的な活動"
        word(0, 8) = "宗教,出版"
        word(0, 9) = "建設"
        word(0, 10) = "開発,研究"
        word(0, 11) = "非現世的なこと"
        word(1, 0) = "気転"
        word(1, 1) = "商才"
        word(1, 2) = "学才"
        word(1, 3) = "引越"
        word(1, 4) = "賢児"
        word(1, 5) = "秘書"
        word(1, 6) = "広報"
        word(1, 7) = "過敏"
        word(1, 8) = "才知"
        word(1, 9) = "文才"
        word(1, 10) = "不信"
        word(1, 11) = "陰気"
        mean(3) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "金星"
        base = "妻,財産,愛,芸術"
        thing = "恋愛,結婚,装飾品"
        body = ""
        word(0, 0) = "衝動的"
        word(0, 1) = "実利的"
        word(0, 2) = "理知的"
        word(0, 3) = "受動的"
        word(0, 4) = "顕示的"
        word(0, 5) = "批判的"
        word(0, 6) = "外交的"
        word(0, 7) = "秘密的"
        word(0, 8) = "野心的"
        word(0, 9) = "独善的"
        word(0, 10) = "博愛的"
        word(0, 11) = "陰湿的"
        word(1, 0) = "美貌"
        word(1, 1) = "金力"
        word(1, 2) = "芸術"
        word(1, 3) = "平安"
        word(1, 4) = "芸能"
        word(1, 5) = "失財"
        word(1, 6) = "結婚"
        word(1, 7) = "遺産"
        word(1, 8) = "出版"
        word(1, 9) = "政治"
        word(1, 10) = "友人"
        word(1, 11) = "邪悪"
        mean(4) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "火星"
        base = "積極性"
        thing = "運動,争い,外科,年下の男"
        body = ""
        word(0, 0) = "早合点,準備不足"
        word(0, 1) = "頑固さ"
        word(0, 2) = "器用さ"
        word(0, 3) = "家庭内の問題"
        word(0, 4) = "自信過剰"
        word(0, 5) = "決断力の欠如"
        word(0, 6) = "油断"
        word(0, 7) = "自暴自棄"
        word(0, 8) = "冒険心の過剰"
        word(0, 9) = "傲慢,我儘"
        word(0, 10) = "無軌道"
        word(0, 11) = "非現実的態度"
        word(1, 0) = "速戦"
        word(1, 1) = "贅沢"
        word(1, 2) = "筆禍"
        word(1, 3) = "損失"
        word(1, 4) = "投機"
        word(1, 5) = "手術"
        word(1, 6) = "離婚"
        word(1, 7) = "裁判"
        word(1, 8) = "客死"
        word(1, 9) = "外科"
        word(1, 10) = "不調"
        word(1, 11) = "詐欺"
        mean(5) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "木星"
        base = "保護"
        thing = "儀式,宗教,研究,妻の里方"
        body = ""
        word(0, 0) = "開発的"
        word(0, 1) = "公平"
        word(0, 2) = "人道的"
        word(0, 3) = "同情的"
        word(0, 4) = "寛大"
        word(0, 5) = "唯物的"
        word(0, 6) = "楽観的"
        word(0, 7) = "利権的"
        word(0, 8) = "唯心的"
        word(0, 9) = "建設的"
        word(0, 10) = "慈悲的"
        word(0, 11) = "利他的"
        word(1, 0) = "同情"
        word(1, 1) = "財産"
        word(1, 2) = "上品"
        word(1, 3) = "幸福"
        word(1, 4) = "投資"
        word(1, 5) = "経営"
        word(1, 6) = "協同"
        word(1, 7) = "財力"
        word(1, 8) = "名誉"
        word(1, 9) = "飲食"
        word(1, 10) = "親友"
        word(1, 11) = "神秘"
        mean(6) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "土星"
        base = "制限"
        thing = "規律,教育,安定,不動産"
        body = ""
        word(0, 0) = "野心的"
        word(0, 1) = "頑固"
        word(0, 2) = "策略的"
        word(0, 3) = "悲観的"
        word(0, 4) = "精神的"
        word(0, 5) = "質素"
        word(0, 6) = "論争的"
        word(0, 7) = "孤独"
        word(0, 8) = "反抗的"
        word(0, 9) = "懐疑的"
        word(0, 10) = "忍従的"
        word(0, 11) = "空想的"
        word(1, 0) = "臆病"
        word(1, 1) = "吝嗇" 'リンショク
        word(1, 2) = "堅実"
        word(1, 3) = "不幸"
        word(1, 4) = "不満"
        word(1, 5) = "病身"
        word(1, 6) = "晩婚"
        word(1, 7) = "損害"
        word(1, 8) = "外患"
        word(1, 9) = "権威"
        word(1, 10) = "心友"
        word(1, 11) = "占星"
        mean(7) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "天王星"
        base = "変化"
        thing = "改革,離別,不安定,電撃"
        body = ""
        word(0, 0) = "自由"
        word(0, 1) = "強情"
        word(0, 2) = "変人"
        word(0, 3) = "風変り"
        word(0, 4) = "楽観的"
        word(0, 5) = "詮索"
        word(0, 6) = "客観的"
        word(0, 7) = "集中的"
        word(0, 8) = "研究的"
        word(0, 9) = "企業的"
        word(0, 10) = "創作的"
        word(0, 11) = "霊視的"
        word(1, 0) = "自由"
        word(1, 1) = "投機"
        word(1, 2) = "発明"
        word(1, 3) = "不安"
        word(1, 4) = "創造"
        word(1, 5) = "突発"
        word(1, 6) = "欲情"
        word(1, 7) = "事故"
        word(1, 8) = "探検"
        word(1, 9) = "融通"
        word(1, 10) = "変心"
        word(1, 11) = "気転"
        mean(8) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "海王星"
        base = "見えないもの"
        thing = "石油,石油製品,霊感,海"
        body = ""
        word(0, 0) = "同情"
        word(0, 1) = "投資"
        word(0, 2) = "詩文"
        word(0, 3) = "理想"
        word(0, 4) = "階級意識"
        word(0, 5) = "霊感"
        word(0, 6) = "想像"
        word(0, 7) = "懐疑"
        word(0, 8) = "野心"
        word(0, 9) = "細心"
        word(0, 10) = "友愛"
        word(0, 11) = "寛大"
        word(1, 0) = "夢想"
        word(1, 1) = "無駄"
        word(1, 2) = "情緒"
        word(1, 3) = "孤独"
        word(1, 4) = "芸術"
        word(1, 5) = "弱気"
        word(1, 6) = "抑圧"
        word(1, 7) = "過敏"
        word(1, 8) = "神秘"
        word(1, 9) = "曖昧"
        word(1, 10) = "同情"
        word(1, 11) = "架空"
        mean(9) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "冥王星"
        base = "極限"
        thing = "原子力,絶頂"
        body = ""
        word(0, 0) = "実行"
        word(0, 1) = "保全"
        word(0, 2) = "理論"
        word(0, 3) = "実験"
        word(0, 4) = "干渉"
        word(0, 5) = "混迷"
        word(0, 6) = "改訂"
        word(0, 7) = "失意"
        word(0, 8) = "拡張"
        word(0, 9) = "強圧"
        word(0, 10) = "自由"
        word(0, 11) = "同情"
        word(1, 0) = "勇気"
        word(1, 1) = "融通"
        word(1, 2) = "適応"
        word(1, 3) = "変動"
        word(1, 4) = "衝動"
        word(1, 5) = "博愛"
        word(1, 6) = "協力"
        word(1, 7) = "正義"
        word(1, 8) = "旅行"
        word(1, 9) = "独力"
        word(1, 10) = "押付"
        word(1, 11) = "神秘"
        mean(10) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "セレス"
        base = "献身"
        thing = "農業,妊娠,永続,献身"
        body = ""
        word(1, 0) = "創造"
        word(1, 1) = "収穫"
        word(1, 2) = "研究"
        word(1, 3) = "忍従"
        word(1, 4) = "発明"
        word(1, 5) = "奉仕"
        word(1, 6) = "献身"
        word(1, 7) = "闘争"
        word(1, 8) = "実務"
        word(1, 9) = "信頼"
        word(1, 10) = "開発"
        word(1, 11) = "引退"
        mean(11) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "パラス"
        base = "調和"
        thing = "経済的なものを含まない純愛"
        body = ""
        word(1, 0) = "芸術"
        word(1, 1) = "賞与"
        word(1, 2) = "文芸"
        word(1, 3) = "安泰"
        word(1, 4) = "芸能"
        word(1, 5) = "福祉"
        word(1, 6) = "社交"
        word(1, 7) = "再建"
        word(1, 8) = "自信"
        word(1, 9) = "役得"
        word(1, 10) = "親友"
        word(1, 11) = "直感"
        mean(12) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "ジュノー"
        base = "権利"
        thing = "権利の主張と弁護"
        body = ""
        word(1, 0) = "主張"
        word(1, 1) = "請求"
        word(1, 2) = "芸力"
        word(1, 3) = "復権"
        word(1, 4) = "愛妾"
        word(1, 5) = "配当"
        word(1, 6) = "恋人"
        word(1, 7) = "自由"
        word(1, 8) = "迷信"
        word(1, 9) = "強権"
        word(1, 10) = "逸脱"
        word(1, 11) = "恋敵"
        mean(13) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "ベスタ"
        base = "義務"
        thing = "義務の履行,厳密な検査"
        body = ""
        word(1, 0) = "禁欲"
        word(1, 1) = "支払"
        word(1, 2) = "浄化"
        word(1, 3) = "責任"
        word(1, 4) = "忍従"
        word(1, 5) = "責務"
        word(1, 6) = "情欲"
        word(1, 7) = "忍耐"
        word(1, 8) = "献身"
        word(1, 9) = "義務"
        word(1, 10) = "義理"
        word(1, 11) = "犠牲"
        mean(14) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "キロン"
        base = "医術,占術"
        thing = ""
        body = ""
        word(1, 0) = ""
        word(1, 1) = ""
        word(1, 2) = ""
        word(1, 3) = ""
        word(1, 4) = ""
        word(1, 5) = ""
        word(1, 6) = ""
        word(1, 7) = ""
        word(1, 8) = ""
        word(1, 9) = ""
        word(1, 10) = ""
        word(1, 11) = ""
        mean(15) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "リリス"
        base = ""
        thing = ""
        body = ""
        word(1, 0) = ""
        word(1, 1) = ""
        word(1, 2) = ""
        word(1, 3) = ""
        word(1, 4) = ""
        word(1, 5) = ""
        word(1, 6) = ""
        word(1, 7) = ""
        word(1, 8) = ""
        word(1, 9) = ""
        word(1, 10) = ""
        word(1, 11) = ""
        mean(16) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "ドラゴンヘッド"
        base = "社会性"
        thing = ""
        body = ""
        mean(17) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "ドラゴンテイル"
        base = "反社会性"
        thing = ""
        body = ""
        mean(18) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "牡羊座"
        base = "粗野"
        thing = "始め,前面,実行力"
        body = "顔"
        depend(0) = 5
        depend(1) = 0
        depend(2) = 1
        deacon(0) = 5
        deacon(1) = 1
        deacon(2) = 6
        mean(19) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "牡牛座"
        base = "保守"
        thing = "声楽,後面,安定的"
        body = "首"
        depend(0) = 4
        depend(1) = 0
        depend(2) = 2
        deacon(0) = 4
        deacon(1) = 3
        deacon(2) = 7
        mean(20) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "双子座"
        base = "鋭敏"
        thing = "話術,安請け合い"
        body = "胸,肺"
        depend(0) = 3
        depend(1) = 0
        depend(2) = 0
        deacon(0) = 3
        deacon(1) = 4
        deacon(2) = 8
        mean(21) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "蟹座"
        base = "感得"
        thing = "納得,ヒステリー"
        body = "胃"
        depend(0) = 2
        depend(1) = 0
        depend(2) = 6
        deacon(0) = 2
        deacon(1) = 10
        deacon(2) = 9
        mean(22) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "獅子座"
        base = "自信"
        thing = "顕示,派手なこと"
        body = "心臓"
        depend(0) = 1
        depend(1) = 0
        depend(2) = 10
        deacon(0) = 1
        deacon(1) = 6
        deacon(2) = 5
        mean(23) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "乙女座"
        base = "分析"
        thing = "理解,批判的"
        body = "腹"
        depend(0) = 3
        depend(1) = 0
        depend(2) = 3
        deacon(0) = 3
        deacon(1) = 7
        deacon(2) = 4
        mean(24) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "天秤座"
        base = "気転"
        thing = "平衡,外交的付き合い"
        body = "腰"
        depend(0) = 4
        depend(1) = 0
        depend(2) = 7
        deacon(0) = 4
        deacon(1) = 8
        deacon(2) = 3
        mean(25) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "蠍座"
        base = "情熱"
        thing = "執着,計画的実行"
        body = "性器"
        depend(0) = 10
        depend(1) = 5
        depend(2) = 8
        deacon(0) = 10
        deacon(1) = 9
        deacon(2) = 2
        mean(26) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "射手座"
        base = "冒険"
        thing = "目的,やりっぱなし"
        body = "上脚"
        depend(0) = 6
        depend(1) = 0
        depend(2) = 0
        deacon(0) = 6
        deacon(1) = 5
        deacon(2) = 1
        mean(27) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "山羊座"
        base = "自我"
        thing = "頑固,頑張り"
        body = "骨格"
        depend(0) = 7
        depend(1) = 0
        depend(2) = 5
        deacon(0) = 7
        deacon(1) = 4
        deacon(2) = 3
        mean(28) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "水瓶座"
        base = "独創"
        thing = "発明,博愛,理想"
        body = "脚部"
        depend(0) = 8
        depend(1) = 7
        depend(2) = 9
        deacon(0) = 8
        deacon(1) = 3
        deacon(2) = 4
        mean(29) = New Mean(name, base, thing, body, depend, deacon, word)
        name = "魚座"
        base = "交感"
        thing = "霊的,曖昧"
        body = "足の裏"
        depend(0) = 9
        depend(1) = 6
        depend(2) = 4
        deacon(0) = 9
        deacon(1) = 2
        deacon(2) = 10
        mean(30) = New Mean(name, base, thing, body, depend, deacon, word)
    



  
        Make(True)
        Timer1.Start()
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As System.EventArgs) Handles Timer1.Tick
        FrameMove()
    End Sub

    Private Sub ButtonMake_Click(sender As System.Object, e As System.EventArgs) Handles ButtonMake.Click
        Make(False)
    End Sub

    Private Sub ButtonRewind_Click(sender As System.Object, e As System.EventArgs) Handles ButtonRewind.Click
        Rewind()
    End Sub

    Private Sub ButtonRun_Click(sender As System.Object, e As System.EventArgs) Handles ButtonRun.Click
        Run()
    End Sub

    Private Sub ButtonPause_Click(sender As System.Object, e As System.EventArgs) Handles ButtonPause.Click
        Pause()
    End Sub

    Private Sub ButtonExport_Click(sender As System.Object, e As System.EventArgs) Handles ButtonExport.Click
        Export()
    End Sub

    Private Sub ButtonReading_Click(sender As System.Object, e As System.EventArgs) Handles ButtonReading.Click
        Reading()
    End Sub

    'キーワード抽出
    Private Sub Reading()
        Dim f As Form3 = New Form3()
        DispText(f)
        'モーダル開き、戻り値を受け取る
        Dim result As DialogResult = f.ShowDialog()
        If result = DialogResult.OK Then
        End If
        f.Dispose()
    End Sub

    '巻き戻し
    Private Sub Rewind()
        dt = -60.0 * 60.0 * Double.Parse(TextBoxSpeed.Text)
    End Sub

    '再生
    Private Sub Run()
        dt = 60.0 * 60.0 * Double.Parse(TextBoxSpeed.Text)
    End Sub

    '一時停止
    Private Sub Pause()
        dt = 0.0
    End Sub

    'セーブ
    Private Sub Export()
        Dim sfd As New SaveFileDialog()

        sfd.FileName = "新しいファイル.jpg"
        sfd.Filter = _
         "jpgファイル(*.jpg;*.jpeg)|*.jpg;*.jpeg|すべてのファイル(*.*)|*.*"
        sfd.FilterIndex = 2
        sfd.Title = "保存先のファイルを選択してください"
        sfd.RestoreDirectory = True

        If sfd.ShowDialog() = DialogResult.OK Then
            Dim bmp As New Bitmap(PictureBoxHS.Image)
            bmp.Save(sfd.FileName, System.Drawing.Imaging.ImageFormat.Jpeg)
            bmp.Dispose()
        End If
    End Sub

    'キーワード出力
    Private Sub DispText(ByVal f As Form3)

        f.TextBox1.Text = "アスペクトは赤は良い相関です。青は悪い相関です。" + vbCrLf _
            + "緑は努力を要します。黄は組合せによります。" + vbCrLf _
            + "薄い色は角度が外れていて、濃い色は角度がぴったりです" + vbCrLf + vbCrLf




        Dim deg As Double
        Dim deg1 As Double
        Dim deg2 As Double
        Dim deg3 As Double
        Dim b As Boolean
        Dim bplt(13) As Integer
        Dim i As Integer
        Dim j As Integer



        f.TextBox1.Text = f.TextBox1.Text + "Outer Circle を見ます" + vbCrLf + vbCrLf
        For i = 1 To 10
            deg = planet(0, i).m_el Mod 360.0
            If deg < 0.0 Then
                deg = deg + 360.0
            End If
            f.TextBox1.Text = f.TextBox1.Text + mean(i).name + " は " + mean(Math.Floor(deg / 30.0) + 19).name + " にあります" + vbCrLf
            f.TextBox1.Text = f.TextBox1.Text + mean(i).name + " の基本的意味は " + mean(i).base + vbCrLf
            f.TextBox1.Text = f.TextBox1.Text + mean(i).name + " の当てはまる事柄は " + mean(i).thing + vbCrLf
            f.TextBox1.Text = f.TextBox1.Text + mean(Math.Floor(deg / 30.0) + 19).name + " の基本的意味は " + mean(Math.Floor(deg / 30.0) + 19).base + vbCrLf
            f.TextBox1.Text = f.TextBox1.Text + mean(Math.Floor(deg / 30.0) + 19).name + " の当てはまる事柄は " + mean(Math.Floor(deg / 30.0) + 19).thing + vbCrLf
            f.TextBox1.Text = f.TextBox1.Text + "この組み合わせのキーワードは " + mean(i).word(0, Math.Floor(deg / 30.0)) + vbCrLf + vbCrLf
        Next

        For i = 1 To 14
            For j = 0 To 11
                b = False
                deg1 = planet(0, 0).m_hs(j)
                If j = 11 Then
                    deg2 = planet(0, 0).m_hs(0)
                Else
                    deg2 = planet(0, 0).m_hs(j + 1)
                End If
                deg3 = deg2 - deg1
                If deg3 < 0.0 Then
                    deg3 = deg3 + 360.0
                    b = True
                End If
                deg = planet(0, i).m_el
                If b Then
                    If deg < 30.0 Then
                        deg = deg + 360.0

                    End If
                End If
                If deg1 <= deg And deg <= deg1 + deg3 Then
                    bplt(i - 1) = j
                    Exit For
                End If
            Next
        Next

        For i = 0 To 11
            f.TextBox1.Text = f.TextBox1.Text + "第" + String.Format("{0}", i + 1) + "ハウス には " + vbCrLf
            For j = 1 To 14
                If bplt(j - 1) = i Then
                    f.TextBox1.Text = f.TextBox1.Text + mean(j).name + ","
                End If
            Next
            f.TextBox1.Text = f.TextBox1.Text + vbCrLf + "があります" + vbCrLf + "キーワードは "
            For j = 1 To 14
                If bplt(j - 1) = i Then
                    f.TextBox1.Text = f.TextBox1.Text + mean(j).word(1, i) + ","
                End If
            Next
            f.TextBox1.Text = f.TextBox1.Text + " です" + vbCrLf + vbCrLf
        Next


        If chart Then
            Exit Sub
        End If



        f.TextBox1.Text = f.TextBox1.Text + "Inner Circle を見ます" + vbCrLf + vbCrLf
        For i = 1 To 10
            deg = planet(1, i).m_el Mod 360.0
            If deg < 0.0 Then
                deg = deg + 360.0
            End If
            f.TextBox1.Text = f.TextBox1.Text + mean(i).name + " は " + mean(Math.Floor(deg / 30.0) + 19).name + " にあります" + vbCrLf
            f.TextBox1.Text = f.TextBox1.Text + mean(i).name + " の基本的意味は " + mean(i).base + vbCrLf
            f.TextBox1.Text = f.TextBox1.Text + mean(i).name + " の当てはまる事柄は " + mean(i).thing + vbCrLf
            f.TextBox1.Text = f.TextBox1.Text + mean(Math.Floor(deg / 30.0) + 19).name + " の基本的意味は " + mean(Math.Floor(deg / 30.0) + 19).base + vbCrLf
            f.TextBox1.Text = f.TextBox1.Text + mean(Math.Floor(deg / 30.0) + 19).name + " の当てはまる事柄は " + mean(Math.Floor(deg / 30.0) + 19).thing + vbCrLf
            f.TextBox1.Text = f.TextBox1.Text + "この組み合わせのキーワードは " + mean(i).word(0, Math.Floor(deg / 30.0)) + vbCrLf + vbCrLf
        Next

        For i = 1 To 14
            For j = 0 To 11
                b = False
                deg1 = planet(1, 0).m_hs(j)
                If j = 11 Then
                    deg2 = planet(1, 0).m_hs(0)
                Else
                    deg2 = planet(1, 0).m_hs(j + 1)
                End If
                deg3 = deg2 - deg1
                If deg3 < 0.0 Then
                    deg3 = deg3 + 360.0
                    b = True
                End If
                deg = planet(1, i).m_el
                If b Then
                    If deg < 30.0 Then
                        deg = deg + 360.0

                    End If
                End If
                If deg1 <= deg And deg <= deg1 + deg3 Then
                    bplt(i - 1) = j
                    Exit For
                End If
            Next
        Next

        For i = 0 To 11
            f.TextBox1.Text = f.TextBox1.Text + "第" + String.Format("{0}", i + 1) + "ハウス には " + vbCrLf
            For j = 1 To 14
                If bplt(j - 1) = i Then
                    f.TextBox1.Text = f.TextBox1.Text + mean(j).name + ","
                End If
            Next
            f.TextBox1.Text = f.TextBox1.Text + vbCrLf + "があります" + vbCrLf + "キーワードは "
            For j = 1 To 14
                If bplt(j - 1) = i Then
                    f.TextBox1.Text = f.TextBox1.Text + mean(j).word(1, i) + ","
                End If
            Next
            f.TextBox1.Text = f.TextBox1.Text + " です" + vbCrLf + vbCrLf
        Next

    End Sub

    '惑星位置初期化再計算
    Private Sub PlanetInit(ByVal z As Integer, ByVal y As Integer, ByVal dat As DateTime, ByVal add As Double)

        Dim i As Integer
        Dim j As Integer
        Dim FileName As String = "PlanetData.txt"
        Dim Reader As IO.StreamReader
        Dim Encode As System.Text.Encoding
        Encode = System.Text.Encoding.GetEncoding("Shift-JIS")

        Reader = New IO.StreamReader(FileName, Encode)

        i = 0
        While Not Reader.EndOfStream
            Dim str As String = Reader.ReadLine()

            Dim tkn() As String = str.Split(",")
            For j = 0 To tkn.Length - 1
                Dim removeChars As Char() = New Char() {vbTab, " "}
                For Each c As Char In removeChars
                    tkn(j) = tkn(j).Replace(c.ToString(), "")
                Next
            Next

            If Not tkn(0)(0).ToString() = "#" Then '#コメント
                Dim PlanetName As String = tkn(0)
                Dim PlanetNo As Integer = Integer.Parse(tkn(1))
                Dim EpochYY As Integer = Integer.Parse(tkn(2))
                Dim EpochMM As Integer = Integer.Parse(tkn(3))
                Dim EpochDD As Integer = Integer.Parse(tkn(4))
                Dim Epochh As Integer = Integer.Parse(tkn(5))
                Dim Epochm As Integer = Integer.Parse(tkn(6))
                Dim Epochs As Integer = Integer.Parse(tkn(7))
                Dim a As Double = Double.Parse(tkn(8))
                Dim e As Double = Double.Parse(tkn(9))
                Dim m0 As Double = Double.Parse(tkn(10))
                Dim npd As Double = Double.Parse(tkn(11))
                Dim ra As Double = Double.Parse(tkn(12))
                Dim rb As Double = Double.Parse(tkn(13))
                Dim p As Double = Double.Parse(tkn(14))
                Dim ss As Double = Double.Parse(tkn(15))
                Dim ii As Double = Double.Parse(tkn(16))
                Dim ww As Double = Double.Parse(tkn(17))
                Dim m As Double = Double.Parse(tkn(18))
                Dim r As Double = Double.Parse(tkn(19))

                Dim dat0 As New DateTime(EpochYY, EpochMM, EpochDD, Epochh, Epochm, Epochs)
                Dim ddat As Double = (dat - dat0).TotalDays - add

                If i = 0 Then
                    planet(y, i) = New Planet(PlanetNo, ddat, dat0, a, e, m0, npd, ra, rb, p, ss, ii, ww, m, r)
                ElseIf i = 2 Then
                    planet(y, i) = New Planet(PlanetNo, ddat, dat0, add, planet(y, 0), True)
                ElseIf i < 16 Then
                    planet(y, i) = New Planet(PlanetNo, ddat, dat0, a, e, m0, npd, ra, rb, p, ss, ii, ww, m, r, planet(y, 0))
                ElseIf i < 21 Then
                    planet(y, i) = New Planet(PlanetNo, ddat, dat0, i - 16, planet(y, 0))
                Else
                    planet(y, i) = New Planet(PlanetNo, ddat, dat0, m0, planet(y, 0))
                End If

                If i = z Then
                    Exit While
                End If
                i = i + 1
            End If
        End While
        Reader.Close()
    End Sub

    'ディスプレイ回転座標
    Private Function CirclePnt(ByVal r As Double, ByVal th As Double) As Vector
        Dim v As Vector = New Vector(2)
        v.x(0) = -r * Math.Cos(-th)
        v.x(1) = -r * Math.Sin(-th)
        Return v
    End Function

    '描画
    Private Sub DrawMount(ByVal sw As Boolean)

        Dim canvas As New Bitmap(PictureBoxHS.Width, PictureBoxHS.Height)
        Dim gPic As Graphics = Graphics.FromImage(canvas)
        gPic.FillRectangle(Brushes.White, 0, 0, 541, 1440)

        If sw Then
            DrawMountSingle(gPic)
        Else
            DrawMountDouble(gPic)
        End If

        gPic.Dispose()
        PictureBoxHS.Image = canvas
        bitmap = canvas
    End Sub

    '角度表示
    Private Sub DrawDeg(ByVal deg As Double, ByVal x As Integer, ByVal y As Integer, ByVal n As Integer, ByVal b As Boolean, ByVal gPic As Graphics, ByVal fnt As Font, ByVal imageAttr As System.Drawing.Imaging.ImageAttributes)
        Dim s As String
        Dim sf As New StringFormat
        Dim stringSize As SizeF
        Dim stringSize2 As SizeF
        Dim rc As Rectangle


        If b Then
            x = x + 5
        Else
            x = x - 5
        End If


        s = String.Format("{0}", Math.Floor(deg Mod 30.0))
        stringSize = gPic.MeasureString(s, fnt, 1000, sf)
        gPic.DrawString(s, fnt, Brushes.Black, x, y)
        rc = New Rectangle(x + stringSize.Width - 4, y - 4, 20, 20)
        gPic.DrawImage(tip(Math.Floor(deg / 30.0) + 21), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr)
        s = String.Format("{0}", Math.Floor((deg - Math.Floor(deg)) * 100.0))
        stringSize2 = gPic.MeasureString(s, fnt, 1000, sf)
        gPic.DrawString(s, fnt, Brushes.Black, x + stringSize.Width + 20 - 6, y)

        If 18 < n Then
            Exit Sub
        End If

        If b Then
            If planet(1, n).m_rev Then
                s = "R"
                stringSize = gPic.MeasureString(s, fnt, 1000, sf)
                gPic.DrawString(s, fnt, Brushes.Black, x - stringSize.Width, y)
            End If
        Else
            If planet(0, n).m_rev Then
                s = "R"
                gPic.DrawString(s, fnt, Brushes.Black, x + stringSize.Width + stringSize2.Width + 20 - 6, y)
            End If
        End If

    End Sub

    '一重円表示
    Private Sub DrawMountSingle(ByVal gPic As Graphics)

        gPic.DrawEllipse(Pens.Gray, 0, 0, 479, 479)
        gPic.DrawEllipse(Pens.Gray, 40, 40, 399, 399)
        gPic.DrawEllipse(Pens.Gray, 80, 80, 319, 319)


        Dim vec0 As Vector = New Vector(2)
        vec0.x(0) = 0.0
        vec0.x(1) = 0.0

        Dim rc As Rectangle
        Dim vec1 As Vector
        Dim vec2 As Vector
        Dim vec3 As Vector
        Dim vec4 As Vector
        Dim i As Integer
        Dim j As Integer
        Dim d As Double

        '星座
        For i = 0 To 11
            vec1 = CirclePnt(200.0, 30.0 * CType(i, Double) * CNST_DR)
            gPic.DrawLine(Pens.Gray, CType(vec0.x(0), Integer) + 240, CType(vec0.x(1), Integer) + 240, CType(vec1.x(0), Integer) + 240, CType(vec1.x(1), Integer) + 240)
            For j = 1 To 2
                vec2 = CirclePnt(160.0, (30.0 * CType(i, Double) + 10.0 * CType(j, Double)) * CNST_DR)
                vec3 = CirclePnt(168.0, (30.0 * CType(i, Double) + 10.0 * CType(j, Double)) * CNST_DR)
                gPic.DrawLine(Pens.Gray, CType(vec2.x(0), Integer) + 240, CType(vec2.x(1), Integer) + 240, CType(vec3.x(0), Integer) + 240, CType(vec3.x(1), Integer) + 240)
                vec2 = CirclePnt(160.0, (30.0 * CType(i, Double) + 5.0 * CType(j * 2 - 1, Double)) * CNST_DR)
                vec3 = CirclePnt(164.0, (30.0 * CType(i, Double) + 5.0 * CType(j * 2 - 1, Double)) * CNST_DR)
                gPic.DrawLine(Pens.Gray, CType(vec2.x(0), Integer) + 240, CType(vec2.x(1), Integer) + 240, CType(vec3.x(0), Integer) + 240, CType(vec3.x(1), Integer) + 240)
            Next
            vec2 = CirclePnt(160.0, (30.0 * CType(i, Double) + 5.0 * CType(j * 2 - 1, Double)) * CNST_DR)
            vec3 = CirclePnt(164.0, (30.0 * CType(i, Double) + 5.0 * CType(j * 2 - 1, Double)) * CNST_DR)
            gPic.DrawLine(Pens.Gray, CType(vec2.x(0), Integer) + 240, CType(vec2.x(1), Integer) + 240, CType(vec3.x(0), Integer) + 240, CType(vec3.x(1), Integer) + 240)

            vec4 = CirclePnt(180.0, planet(0, i + 21).m_el * CNST_DR)
            Dim lowerColor As Color = Color.FromArgb(245, 0, 245)
            Dim upperColor As Color = Color.FromArgb(255, 0, 255)
            Dim imageAttr As New System.Drawing.Imaging.ImageAttributes()
            imageAttr.SetColorKey(lowerColor, upperColor, System.Drawing.Imaging.ColorAdjustType.Default)
            rc = New Rectangle(CType(vec4.x(0), Integer) - 16 + 240, CType(vec4.x(1), Integer) - 16 + 240, 32, 32)
            gPic.DrawImage(tip(i + 21), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr)


        Next
        Dim fnt As New Font("MS UI Gothic", 10)
        Dim aaa As Double

        'ハウス
        For i = 0 To 11
            vec1 = CirclePnt(240.0, planet(0, 0).m_hs(i) * CNST_DR)
            vec2 = CirclePnt(200.0, planet(0, 0).m_hs(i) * CNST_DR)
            gPic.DrawLine(Pens.Cyan, CType(vec1.x(0), Integer) + 240, CType(vec1.x(1), Integer) + 240, CType(vec2.x(0), Integer) + 240, CType(vec2.x(1), Integer) + 240)
            If i = 11 Then
                aaa = ((planet(0, 0).m_hs(0) - planet(0, 0).m_hs(i)) / 2.0 + planet(0, 0).m_hs(i))
                If (planet(0, 0).m_hs(0) < 180.0) And (180.0 < planet(0, 0).m_hs(i)) Then
                    aaa = (aaa + 180.0) Mod 360.0
                End If
                If aaa < 0.0 Then
                    aaa = aaa + 360.0
                End If
                vec3 = CirclePnt(220.0 - (0 * 130), aaa * CNST_DR)
            Else
                aaa = ((planet(0, 0).m_hs(i + 1) - planet(0, 0).m_hs(i)) / 2.0 + planet(0, 0).m_hs(i))
                If (planet(0, 0).m_hs(i + 1) < 180.0) And (180.0 < planet(0, 0).m_hs(i)) Then
                    aaa = (aaa + 180.0) Mod 360.0
                End If
                If aaa < 0.0 Then
                    aaa = aaa + 360.0
                End If
                vec3 = CirclePnt(220.0 - (0 * 130), aaa * CNST_DR)
            End If
            gPic.DrawString(String.Format("{0}", i + 1), fnt, Brushes.Black, CType(vec3.x(0), Integer) - 5 + 240, CType(vec3.x(1), Integer) - 5 + 240)
        Next
        vec4 = CirclePnt(220.0, planet(0, 0).m_hs(0) * CNST_DR)
        Dim lowerColor2 As Color = Color.FromArgb(245, 0, 245)
        Dim upperColor2 As Color = Color.FromArgb(255, 0, 255)
        Dim imageAttr2 As New System.Drawing.Imaging.ImageAttributes()
        imageAttr2.SetColorKey(lowerColor2, upperColor2, System.Drawing.Imaging.ColorAdjustType.Default)
        rc = New Rectangle(CType(vec4.x(0), Integer) - 16 + 240, CType(vec4.x(1), Integer) - 16 + 240, 32, 32)
        gPic.DrawImage(tip(19), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr2)
        vec4 = CirclePnt(220.0, planet(0, 0).m_hs(9) * CNST_DR)
        rc = New Rectangle(CType(vec4.x(0), Integer) - 16 + 240, CType(vec4.x(1), Integer) - 16 + 240, 32, 32)
        gPic.DrawImage(tip(20), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr2)

        '惑星
        For i = 1 To 18
            d = 0.0
            For j = 1 To i - 1
                If (Not i = j) And (planet(0, j).m_el - 10.0 < planet(0, i).m_el) And (planet(0, i).m_el < planet(0, j).m_el + 10.0) Then
                    d = d - 20.0
                End If
            Next
            vec4 = CirclePnt(140.0 + d, planet(0, i).m_el * CNST_DR)
            Dim lowerColor As Color = Color.FromArgb(245, 0, 245)
            Dim upperColor As Color = Color.FromArgb(255, 0, 255)
            Dim imageAttr As New System.Drawing.Imaging.ImageAttributes()
            imageAttr.SetColorKey(lowerColor, upperColor, System.Drawing.Imaging.ColorAdjustType.Default)
            rc = New Rectangle(CType(vec4.x(0), Integer) - 16 + 240, CType(vec4.x(1), Integer) - 16 + 240, 32, 32)
            gPic.DrawImage(tip(i), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr)

        Next

        'アスペクト表
        Dim dat As Date = New Date(dat1.Year, dat1.Month, dat1.Day, dat1.Hour, dat1.Minute, dat1.Second)
        Dim add As Double
        Dim hh As Double
        Dim mm As Double
        Dim ss As Double
        Dim s As String
        Dim sf As New StringFormat
        Dim stringSize As SizeF
        gPic.DrawString("Outer Circle", fnt, Brushes.Black, 0, 470)
        add = (longitude1 Mod 180.0) / 360.0
        hh = Math.Floor(add * 24.0)
        mm = Math.Floor(add * 24.0 * 60.0) Mod 60
        ss = Math.Floor(add * 24.0 * 60.0 * 60.0) Mod 60
        If hh < 0.0 Or mm < 0.0 Or ss < 0.0 Then
            gPic.DrawString(dat.AddSeconds(time) + String.Format(" + {0:00}:{1:00}:{2:00}", -hh, -mm, -ss), fnt, Brushes.Black, 0, 480)
        Else
            gPic.DrawString(dat.AddSeconds(time) + String.Format(" - {0:00}:{1:00}:{2:00}", hh, mm, ss), fnt, Brushes.Black, 0, 480)
        End If
        add = planet(0, 0).m_hs(0)
        s = String.Format("Asc = ")
        stringSize = gPic.MeasureString(s, fnt, 1000, sf)
        gPic.DrawString(s, fnt, Brushes.Black, 0, 495)
        DrawDeg(add, stringSize.Width, 495, 19, False, gPic, fnt, imageAttr2)
        add = planet(0, 0).m_hs(9)
        s = String.Format("Mc = ")
        stringSize = gPic.MeasureString(s, fnt, 1000, sf)
        gPic.DrawString(s, fnt, Brushes.Black, 0, 515)
        DrawDeg(add, stringSize.Width, 515, 20, False, gPic, fnt, imageAttr2)


        '濃度塗りつぶし
        For i = 0 To 19
            For j = i To 19
                If i = j Then
                    Continue For
                End If
                If asp(0, i, j) Then
                    rc = New Rectangle(i * 20, 930 - (20 - j) * 20, 20, 20)
                    gPic.FillRectangle(brs(asp(0, i, j)), rc)
                End If
            Next
        Next

        '罫線
        For i = 0 To 19
            If i = 0 Then
                gPic.DrawLine(Pens.Gray, 0, 930 - 19 * 20, 0, 930)
                gPic.DrawLine(Pens.Gray, 0, 930, 380, 930)
            Else
                gPic.DrawLine(Pens.Gray, i * 20, 930 - (20 - i) * 20, i * 20, 930)
                gPic.DrawLine(Pens.Gray, 0, 930 - (20 - i) * 20, i * 20, 930 - (20 - i) * 20)
            End If
        Next

        '惑星角度
        i = 0
        For j = 1 To 18
            rc = New Rectangle(i * 20, 530 + i * 20, 20, 20)
            gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr2)
            add = planet(0, j).m_el
            DrawDeg(add, 25 + i * 20, 535 + i * 20, j, False, gPic, fnt, imageAttr2)
            i = i + 1
        Next
        rc = New Rectangle(i * 20, 530 + i * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr2)
        add = planet(0, 0).m_hs(0)
        DrawDeg(add, 25 + i * 20, 535 + i * 20, j, False, gPic, fnt, imageAttr2)
        i = i + 1
        j = j + 1
        rc = New Rectangle(i * 20, 530 + i * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr2)
        add = planet(0, 0).m_hs(9)
        DrawDeg(add, 25 + i * 20, 535 + i * 20, j, False, gPic, fnt, imageAttr2)
        i = i + 1
        j = j + 1

        'アスペクト
        For i = 0 To 19
            For j = i To 19
                If i = j Then
                    Continue For
                End If
                If asp(0, i, j) Then
                    rc = New Rectangle(i * 20, 930 - (20 - j) * 20, 20, 20)
                    gPic.DrawImage(tip(Math.Floor(asp(0, i, j) / 2) + 32), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr2)
                End If
            Next
        Next



        fnt.Dispose()

    End Sub

    '二重円表示
    Private Sub DrawMountDouble(ByVal gPic As Graphics)
        gPic.DrawEllipse(Pens.Gray, 0, 0, 479, 479)
        gPic.DrawEllipse(Pens.Gray, 40, 40, 399, 399)
        gPic.DrawEllipse(Pens.Gray, 80, 80, 319, 319)
        gPic.DrawEllipse(Pens.Gray, 140, 140, 199, 199)
        gPic.DrawEllipse(Pens.Gray, 160, 160, 159, 159)


        Dim vec0 As Vector = New Vector(2)
        vec0.x(0) = 0.0
        vec0.x(1) = 0.0

        Dim rc As Rectangle
        Dim vec1 As Vector
        Dim vec2 As Vector
        Dim vec3 As Vector
        Dim vec4 As Vector
        Dim i As Integer
        Dim j As Integer
        Dim a As Integer
        Dim d As Double

        '星座
        For a = 0 To 1
            For i = 0 To 11
                If a = 0 Then
                    vec1 = CirclePnt(200.0, 30.0 * CType(i, Double) * CNST_DR)
                    gPic.DrawLine(Pens.Gray, CType(vec0.x(0), Integer) + 240, CType(vec0.x(1), Integer) + 240, CType(vec1.x(0), Integer) + 240, CType(vec1.x(1), Integer) + 240)
                    vec4 = CirclePnt(180.0, planet(0, i + 21).m_el * CNST_DR)
                    Dim lowerColor As Color = Color.FromArgb(245, 0, 245)
                    Dim upperColor As Color = Color.FromArgb(255, 0, 255)
                    Dim imageAttr As New System.Drawing.Imaging.ImageAttributes()
                    imageAttr.SetColorKey(lowerColor, upperColor, System.Drawing.Imaging.ColorAdjustType.Default)
                    rc = New Rectangle(CType(vec4.x(0), Integer) - 16 + 240, CType(vec4.x(1), Integer) - 16 + 240, 32, 32)
                    gPic.DrawImage(tip(i + 21), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr)
                End If
                For j = 1 To 2
                    vec2 = CirclePnt(160.0 - (a * 80), (30.0 * CType(i, Double) + 10.0 * CType(j, Double)) * CNST_DR)
                    vec3 = CirclePnt(168.0 - (a * 80), (30.0 * CType(i, Double) + 10.0 * CType(j, Double)) * CNST_DR)
                    gPic.DrawLine(Pens.Gray, CType(vec2.x(0), Integer) + 240, CType(vec2.x(1), Integer) + 240, CType(vec3.x(0), Integer) + 240, CType(vec3.x(1), Integer) + 240)
                    vec2 = CirclePnt(160.0 - (a * 80), (30.0 * CType(i, Double) + 5.0 * CType(j * 2 - 1, Double)) * CNST_DR)
                    vec3 = CirclePnt(164.0 - (a * 80), (30.0 * CType(i, Double) + 5.0 * CType(j * 2 - 1, Double)) * CNST_DR)
                    gPic.DrawLine(Pens.Gray, CType(vec2.x(0), Integer) + 240, CType(vec2.x(1), Integer) + 240, CType(vec3.x(0), Integer) + 240, CType(vec3.x(1), Integer) + 240)
                Next
                vec2 = CirclePnt(160.0 - (a * 80), (30.0 * CType(i, Double) + 5.0 * CType(j * 2 - 1, Double)) * CNST_DR)
                vec3 = CirclePnt(164.0 - (a * 80), (30.0 * CType(i, Double) + 5.0 * CType(j * 2 - 1, Double)) * CNST_DR)
                gPic.DrawLine(Pens.Gray, CType(vec2.x(0), Integer) + 240, CType(vec2.x(1), Integer) + 240, CType(vec3.x(0), Integer) + 240, CType(vec3.x(1), Integer) + 240)
            Next
        Next
        For a = 0 To 1
            Dim fnt2 As New Font("MS UI Gothic", 10)

            Dim aaa As Double

            'ハウス
            For i = 0 To 11
                vec1 = CirclePnt(240.0 - (a * 140), planet(a, 0).m_hs(i) * CNST_DR)
                vec2 = CirclePnt(200.0 - (a * 120), planet(a, 0).m_hs(i) * CNST_DR)
                gPic.DrawLine(Pens.Cyan, CType(vec1.x(0), Integer) + 240, CType(vec1.x(1), Integer) + 240, CType(vec2.x(0), Integer) + 240, CType(vec2.x(1), Integer) + 240)
                If i = 11 Then
                    aaa = ((planet(a, 0).m_hs(0) - planet(a, 0).m_hs(i)) / 2.0 + planet(a, 0).m_hs(i))
                    If (planet(a, 0).m_hs(0) < 180.0) And (180.0 < planet(a, 0).m_hs(i)) Then
                        aaa = (aaa + 180.0) Mod 360.0
                    End If
                    If aaa < 0.0 Then
                        aaa = aaa + 360.0
                    End If
                    vec3 = CirclePnt(220.0 - (a * 130), aaa * CNST_DR)
                Else
                    aaa = ((planet(a, 0).m_hs(i + 1) - planet(a, 0).m_hs(i)) / 2.0 + planet(a, 0).m_hs(i))
                    If (planet(a, 0).m_hs(i + 1) < 180.0) And (180.0 < planet(a, 0).m_hs(i)) Then
                        aaa = (aaa + 180.0) Mod 360.0
                    End If
                    If aaa < 0.0 Then
                        aaa = aaa + 360.0
                    End If
                    vec3 = CirclePnt(220.0 - (a * 130), aaa * CNST_DR)
                End If
                gPic.DrawString(String.Format("{0}", i + 1), fnt2, Brushes.Black, CType(vec3.x(0), Integer) - 5 + 240, CType(vec3.x(1), Integer) - 5 + 240)
            Next
            vec4 = CirclePnt(220.0 - (a * 130), planet(a, 0).m_hs(0) * CNST_DR)
            Dim lowerColor2 As Color = Color.FromArgb(245, 0, 245)
            Dim upperColor2 As Color = Color.FromArgb(255, 0, 255)
            Dim imageAttr2 As New System.Drawing.Imaging.ImageAttributes()
            imageAttr2.SetColorKey(lowerColor2, upperColor2, System.Drawing.Imaging.ColorAdjustType.Default)
            rc = New Rectangle(CType(vec4.x(0), Integer) - 16 + 240, CType(vec4.x(1), Integer) - 16 + 240, 32, 32)
            gPic.DrawImage(tip(19), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr2)
            vec4 = CirclePnt(220.0 - (a * 130), planet(a, 0).m_hs(9) * CNST_DR)
            rc = New Rectangle(CType(vec4.x(0), Integer) - 16 + 240, CType(vec4.x(1), Integer) - 16 + 240, 32, 32)
            gPic.DrawImage(tip(20), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr2)


            fnt2.Dispose()

        Next
        '惑星
        For a = 0 To 1
            For i = 1 To 18
                d = 0.0
                For j = 1 To i - 1
                    If (Not i = j) And (planet(a, j).m_el - 10.0 < planet(a, i).m_el) And (planet(a, i).m_el < planet(a, j).m_el + 10.0) Then
                        d = d - 15.0
                    End If
                Next
                vec4 = CirclePnt(140.0 + d - (a * 80), planet(a, i).m_el * CNST_DR)
                Dim lowerColor As Color = Color.FromArgb(245, 0, 245)
                Dim upperColor As Color = Color.FromArgb(255, 0, 255)
                Dim imageAttr As New System.Drawing.Imaging.ImageAttributes()
                imageAttr.SetColorKey(lowerColor, upperColor, System.Drawing.Imaging.ColorAdjustType.Default)
                rc = New Rectangle(CType(vec4.x(0), Integer) - 16 + 240, CType(vec4.x(1), Integer) - 16 + 240, 32, 32)
                gPic.DrawImage(tip(i), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr)

            Next

        Next

        'アスペクト表
        Dim lowerColor3 As Color = Color.FromArgb(245, 0, 245)
        Dim upperColor3 As Color = Color.FromArgb(255, 0, 255)
        Dim imageAttr3 As New System.Drawing.Imaging.ImageAttributes()
        imageAttr3.SetColorKey(lowerColor3, upperColor3, System.Drawing.Imaging.ColorAdjustType.Default)
        Dim dat As Date = New Date(dat1.Year, dat1.Month, dat1.Day, dat1.Hour, dat1.Minute, dat1.Second)
        Dim fnt As New Font("MS UI Gothic", 10)
        Dim add As Double
        Dim hh As Double
        Dim mm As Double
        Dim ss As Double
        Dim s As String
        Dim sf As New StringFormat
        Dim stringSize As SizeF
        gPic.DrawString("Outer Circle", fnt, Brushes.Black, 0, 470)
        add = (longitude1 Mod 180.0) / 360.0
        hh = Math.Floor(add * 24.0)
        mm = Math.Floor(add * 24.0 * 60.0) Mod 60
        ss = Math.Floor(add * 24.0 * 60.0 * 60.0) Mod 60
        If hh < 0.0 Or mm < 0.0 Or ss < 0.0 Then
            gPic.DrawString(dat.AddSeconds(time) + String.Format(" + {0:00}:{1:00}:{2:00}", -hh, -mm, -ss), fnt, Brushes.Black, 0, 480)
        Else
            gPic.DrawString(dat.AddSeconds(time) + String.Format(" - {0:00}:{1:00}:{2:00}", hh, mm, ss), fnt, Brushes.Black, 0, 480)
        End If
        add = planet(0, 0).m_hs(0)
        s = String.Format("Asc = ")
        stringSize = gPic.MeasureString(s, fnt, 1000, sf)
        gPic.DrawString(s, fnt, Brushes.Black, 0, 495)
        DrawDeg(add, stringSize.Width, 495, 19, False, gPic, fnt, imageAttr3)
        add = planet(0, 0).m_hs(9)
        s = String.Format("Mc = ")
        stringSize = gPic.MeasureString(s, fnt, 1000, sf)
        gPic.DrawString(s, fnt, Brushes.Black, 0, 515)
        DrawDeg(add, stringSize.Width, 515, 20, False, gPic, fnt, imageAttr3)
        add = (longitude2 Mod 180.0) / 360.0
        hh = Math.Floor(add * 24.0)
        mm = Math.Floor(add * 24.0 * 60.0) Mod 60
        ss = Math.Floor(add * 24.0 * 60.0 * 60.0) Mod 60
        s = "Inner Circle"
        stringSize = gPic.MeasureString(s, fnt, 1000, sf)
        gPic.DrawString(s, fnt, Brushes.Black, 540 - stringSize.Width, 470)
        If hh < 0.0 Or mm < 0.0 Or ss < 0.0 Then
            s = dat2.ToString() + String.Format(" + {0:00}:{1:00}:{2:00}", -hh, -mm, -ss)
        Else
            s = dat2.ToString() + String.Format(" - {0:00}:{1:00}:{2:00}", hh, mm, ss)
        End If
        stringSize = gPic.MeasureString(s, fnt, 1000, sf)
        gPic.DrawString(s, fnt, Brushes.Black, 540 - stringSize.Width, 480)
        add = planet(1, 0).m_hs(0)
        s = String.Format("Asc = ")
        stringSize = gPic.MeasureString(s, fnt, 1000, sf)
        gPic.DrawString(s, fnt, Brushes.Black, 490 - stringSize.Width, 495)
        DrawDeg(add, 490, 495, 19, True, gPic, fnt, imageAttr3)
        add = planet(1, 0).m_hs(9)
        s = String.Format("Mc = ")
        stringSize = gPic.MeasureString(s, fnt, 1000, sf)
        gPic.DrawString(s, fnt, Brushes.Black, 490 - stringSize.Width, 515)
        DrawDeg(add, 490, 515, 20, True, gPic, fnt, imageAttr3)


  

        'Outer Circle
        '濃度塗りつぶし
        For i = 0 To 19
            For j = i To 19
                If i = j Then
                    Continue For
                End If
                If asp(0, i, j) Then
                    rc = New Rectangle(i * 20, 930 - (20 - j) * 20, 20, 20)
                    gPic.FillRectangle(brs(asp(0, i, j)), rc)
                End If
            Next
        Next

        '罫線
        For i = 0 To 19
            If i = 0 Then
                gPic.DrawLine(Pens.Gray, 0, 930 - 19 * 20, 0, 930)
                gPic.DrawLine(Pens.Gray, 0, 930, 380, 930)
            Else
                gPic.DrawLine(Pens.Gray, i * 20, 930 - (20 - i) * 20, i * 20, 930)
                gPic.DrawLine(Pens.Gray, 0, 930 - (20 - i) * 20, i * 20, 930 - (20 - i) * 20)
            End If
        Next

        '惑星角度
        i = 0
        For j = 1 To 18
            rc = New Rectangle(i * 20, 530 + i * 20, 20, 20)
            gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
            add = planet(0, j).m_el
            DrawDeg(add, 25 + i * 20, 535 + i * 20, j, False, gPic, fnt, imageAttr3)
            i = i + 1
        Next
        rc = New Rectangle(i * 20, 530 + i * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
        add = planet(0, 0).m_hs(0)
        DrawDeg(add, 25 + i * 20, 535 + i * 20, j, False, gPic, fnt, imageAttr3)
        i = i + 1
        j = j + 1
        rc = New Rectangle(i * 20, 530 + i * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
        add = planet(0, 0).m_hs(9)
        DrawDeg(add, 25 + i * 20, 535 + i * 20, j, False, gPic, fnt, imageAttr3)
        i = i + 1
        j = j + 1

        'アスペクト
        For i = 0 To 19
            For j = i To 19
                If i = j Then
                    Continue For
                End If
                If asp(0, i, j) Then
                    rc = New Rectangle(i * 20, 930 - (20 - j) * 20, 20, 20)
                    gPic.DrawImage(tip(Math.Floor(asp(0, i, j) / 2) + 32), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
                End If
            Next
        Next


        'Inner Circle
        '濃度塗りつぶし
        For i = 0 To 19
            For j = i To 19
                If i = j Then
                    Continue For
                End If
                If asp(1, i, j) Then
                    rc = New Rectangle(540 - (20 - j) * 20, 530 + i * 20, 20, 20)
                    gPic.FillRectangle(brs(asp(1, i, j)), rc)
                End If
            Next
        Next

        '罫線
        For i = 0 To 19
            If i = 0 Then
                gPic.DrawLine(Pens.Gray, 540, 550, 540, 910)
                gPic.DrawLine(Pens.Gray, 540 - 19 * 20, 530, 540, 530)
            Else
                gPic.DrawLine(Pens.Gray, 540 - (20 - i) * 20, 530, 540 - (20 - i) * 20, 530 + i * 20)
                gPic.DrawLine(Pens.Gray, 540, 530 + i * 20, 540 - (20 - i) * 20, 530 + i * 20)
            End If
        Next

        '惑星角度
        i = 0
        For j = 1 To 18
            rc = New Rectangle(540 - (20 - i) * 20, 530 + i * 20, 20, 20)
            gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
            add = planet(1, j).m_el
            DrawDeg(add, 540 - (20 - i) * 20 - 50, 535 + i * 20, j, True, gPic, fnt, imageAttr3)
            i = i + 1
        Next
        rc = New Rectangle(540 - (20 - i) * 20, 530 + i * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
        add = planet(1, 0).m_hs(0)
        DrawDeg(add, 540 - (20 - i) * 20 - 50, 535 + i * 20, j, True, gPic, fnt, imageAttr3)
        i = i + 1
        j = j + 1
        rc = New Rectangle(540 - (20 - i) * 20, 530 + i * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
        add = planet(1, 0).m_hs(9)
        DrawDeg(add, 540 - (20 - i) * 20 - 50, 535 + i * 20, j, True, gPic, fnt, imageAttr3)
        i = i + 1
        j = j + 1

        'アスペクト
        For i = 0 To 19
            For j = i To 19
                If i = j Then
                    Continue For
                End If
                If asp(1, i, j) Then
                    rc = New Rectangle(540 - (20 - j) * 20, 530 + i * 20, 20, 20)
                    gPic.DrawImage(tip(Math.Floor(asp(1, i, j) / 2) + 32), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
                End If
            Next
        Next

        'Outer-Inner
        gPic.DrawString("Chemistry of Outer Circle and Inner Circle", fnt, Brushes.Black, 0, 950)
        gPic.DrawString("Outer Circle ＼ Inner Circle", fnt, Brushes.Black, 0, 970)

        '濃度塗りつぶし
        For i = 0 To 19
            For j = 0 To 19
                If asp2(j, i) Then
                    rc = New Rectangle(i * 20 + 20, 1410 - (20 - j) * 20, 20, 20)
                    gPic.FillRectangle(brs(asp2(j, i)), rc)
                End If
            Next
        Next

        '罫線
        For i = 0 To 20
            gPic.DrawLine(Pens.Gray, i * 20 + 20, 1410 - 20 * 20, i * 20 + 20, 1410)
            gPic.DrawLine(Pens.Gray, 0 + 20, 1410 - (20 - i) * 20, 400 + 20, 1410 - (20 - i) * 20)
        Next

        '惑星
        i = 0
        For j = 1 To 17
            rc = New Rectangle(0, 1010 + i * 20, 20, 20)
            gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
            rc = New Rectangle(i * 20 + 20, 1410 - 21 * 20, 20, 20)
            gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
            i = i + 1
        Next
        rc = New Rectangle(0, 1010 + i * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
        rc = New Rectangle(i * 20 + 20, 1410 - 21 * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
        i = i + 1
        j = j + 1
        rc = New Rectangle(0, 1010 + i * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
        rc = New Rectangle(i * 20 + 20, 1410 - 21 * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
        i = i + 1
        j = j + 1
        rc = New Rectangle(0, 1010 + i * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
        rc = New Rectangle(i * 20 + 20, 1410 - 21 * 20, 20, 20)
        gPic.DrawImage(tip(j), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)

        'アスペクト
        For i = 0 To 19
            For j = 0 To 19
                If asp2(j, i) Then
                    rc = New Rectangle(i * 20 + 20, 1410 - (20 - j) * 20, 20, 20)
                    gPic.DrawImage(tip(Math.Floor(asp2(j, i) / 2) + 32), rc, 0, 0, 256, 256, GraphicsUnit.Pixel, imageAttr3)
                End If
            Next
        Next

        fnt.Dispose()
    End Sub

    'アスペクト計算
    Private Sub aspect()
        ReDim asp(1, 19, 19)

        Dim a As Integer
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        For a = 0 To 1
            For i = 0 To 19
                For j = i To 19
                    If i = j Then
                        Continue For
                    End If
                    If i < 18 Then
                        If j < 18 Then
                            For k = 0 To 9
                                If (planet(a, j + 1).m_el + aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, j + 1).m_el + aasp(0, k) + aasp(1, k) / 2.0) _
                                    Or (planet(a, j + 1).m_el - aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, j + 1).m_el - aasp(0, k) + aasp(1, k) / 2.0) Then
                                    asp(a, i, j) = (k + 1) * 2 + 1
                                ElseIf (planet(a, j + 1).m_el + aasp(0, k) - aasp(1, k) <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, j + 1).m_el + aasp(0, k) + aasp(1, k)) _
                                    Or (planet(a, j + 1).m_el - aasp(0, k) - aasp(1, k) <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, j + 1).m_el - aasp(0, k) + aasp(1, k)) Then
                                    asp(a, i, j) = (k + 1) * 2
                                End If
                            Next
                        ElseIf j = 18 Then
                            For k = 0 To 9
                                If (planet(a, 0).m_hs(0) + aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, 0).m_hs(0) + aasp(0, k) + aasp(1, k) / 2.0) _
                                    Or (planet(a, 0).m_hs(0) - aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, 0).m_hs(0) - aasp(0, k) + aasp(1, k) / 2.0) Then
                                    asp(a, i, j) = (k + 1) * 2 + 1
                                ElseIf (planet(a, 0).m_hs(0) + aasp(0, k) - aasp(1, k) <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, 0).m_hs(0) + aasp(0, k) + aasp(1, k)) _
                                    Or (planet(a, 0).m_hs(0) - aasp(0, k) - aasp(1, k) <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, 0).m_hs(0) - aasp(0, k) + aasp(1, k)) Then
                                    asp(a, i, j) = (k + 1) * 2
                                End If
                            Next
                        ElseIf j = 19 Then
                            For k = 0 To 9
                                If (planet(a, 0).m_hs(9) + aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, 0).m_hs(9) + aasp(0, k) + aasp(1, k) / 2.0) _
                                    Or (planet(a, 0).m_hs(9) - aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, 0).m_hs(9) - aasp(0, k) + aasp(1, k) / 2.0) Then
                                    asp(a, i, j) = (k + 1) * 2 + 1
                                ElseIf (planet(a, 0).m_hs(9) + aasp(0, k) - aasp(1, k) <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, 0).m_hs(9) + aasp(0, k) + aasp(1, k)) _
                                    Or (planet(a, 0).m_hs(9) - aasp(0, k) - aasp(1, k) <= planet(a, i + 1).m_el) And (planet(a, i + 1).m_el <= planet(a, 0).m_hs(9) - aasp(0, k) + aasp(1, k)) Then
                                    asp(a, i, j) = (k + 1) * 2
                                End If
                            Next
                        End If
                    ElseIf i = 18 Then
                        If j < 18 Then
                            For k = 0 To 9
                                If (planet(a, j + 1).m_el + aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, j + 1).m_el + aasp(0, k) + aasp(1, k) / 2.0) _
                                    Or (planet(a, j + 1).m_el - aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, j + 1).m_el - aasp(0, k) + aasp(1, k) / 2.0) Then
                                    asp(a, i, j) = (k + 1) * 2 + 1
                                ElseIf (planet(a, j + 1).m_el + aasp(0, k) - aasp(1, k) <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, j + 1).m_el + aasp(0, k) + aasp(1, k)) _
                                    Or (planet(a, j + 1).m_el - aasp(0, k) - aasp(1, k) <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, j + 1).m_el - aasp(0, k) + aasp(1, k)) Then
                                    asp(a, i, j) = (k + 1) * 2
                                End If
                            Next
                        ElseIf j = 18 Then
                            For k = 0 To 9
                                If (planet(a, 0).m_hs(0) + aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, 0).m_hs(0) + aasp(0, k) + aasp(1, k) / 2.0) _
                                    Or (planet(a, 0).m_hs(0) - aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, 0).m_hs(0) - aasp(0, k) + aasp(1, k) / 2.0) Then
                                    asp(a, i, j) = (k + 1) * 2 + 1
                                ElseIf (planet(a, 0).m_hs(0) + aasp(0, k) - aasp(1, k) <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, 0).m_hs(0) + aasp(0, k) + aasp(1, k)) _
                                    Or (planet(a, 0).m_hs(0) - aasp(0, k) - aasp(1, k) <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, 0).m_hs(0) - aasp(0, k) + aasp(1, k)) Then
                                    asp(a, i, j) = (k + 1) * 2
                                End If
                            Next
                        ElseIf j = 19 Then
                            For k = 0 To 9
                                If (planet(a, 0).m_hs(9) + aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, 0).m_hs(9) + aasp(0, k) + aasp(1, k) / 2.0) _
                                    Or (planet(a, 0).m_hs(9) - aasp(0, k) - aasp(1, k) / 2.0 <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, 0).m_hs(9) - aasp(0, k) + aasp(1, k) / 2.0) Then
                                    asp(a, i, j) = (k + 1) * 2 + 1
                                ElseIf (planet(a, 0).m_hs(9) + aasp(0, k) - aasp(1, k) <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, 0).m_hs(9) + aasp(0, k) + aasp(1, k)) _
                                    Or (planet(a, 0).m_hs(9) - aasp(0, k) - aasp(1, k) <= planet(a, 0).m_hs(0)) And (planet(a, 0).m_hs(0) <= planet(a, 0).m_hs(9) - aasp(0, k) + aasp(1, k)) Then
                                    asp(a, i, j) = (k + 1) * 2
                                End If
                            Next
                        End If
                    ElseIf i <= 19 Then
                        Exit For
                    End If
                Next
            Next
        Next
    End Sub

    'Outer-Innerアスペクト計算
    Private Sub aspect2()
        ReDim asp2(19, 19)

        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        For i = 0 To 19
            For j = 0 To 19
                If i < 18 Then
                    If j < 18 Then
                        For k = 0 To 9
                            If (planet(1, j + 1).m_el + aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, j + 1).m_el + aasp(0, k) + aasp(1, k) / 2.0) _
                                Or (planet(1, j + 1).m_el - aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, j + 1).m_el - aasp(0, k) + aasp(1, k) / 2.0) Then
                                asp2(i, j) = (k + 1) * 2 + 1
                            ElseIf (planet(1, j + 1).m_el + aasp(0, k) - aasp(1, k) <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, j + 1).m_el + aasp(0, k) + aasp(1, k)) _
                                Or (planet(1, j + 1).m_el - aasp(0, k) - aasp(1, k) <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, j + 1).m_el - aasp(0, k) + aasp(1, k)) Then
                                asp2(i, j) = (k + 1) * 2
                            End If
                        Next
                    ElseIf j = 18 Then
                        For k = 0 To 9
                            If (planet(1, 0).m_hs(0) + aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, 0).m_hs(0) + aasp(0, k) + aasp(1, k) / 2.0) _
                                Or (planet(1, 0).m_hs(0) - aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, 0).m_hs(0) - aasp(0, k) + aasp(1, k) / 2.0) Then
                                asp2(i, j) = (k + 1) * 2 + 1
                            ElseIf (planet(1, 0).m_hs(0) + aasp(0, k) - aasp(1, k) <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, 0).m_hs(0) + aasp(0, k) + aasp(1, k)) _
                                Or (planet(1, 0).m_hs(0) - aasp(0, k) - aasp(1, k) <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, 0).m_hs(0) - aasp(0, k) + aasp(1, k)) Then
                                asp2(i, j) = (k + 1) * 2
                            End If
                        Next
                    ElseIf j = 19 Then
                        For k = 0 To 9
                            If (planet(1, 0).m_hs(9) + aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, 0).m_hs(9) + aasp(0, k) + aasp(1, k) / 2.0) _
                                Or (planet(1, 0).m_hs(9) - aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, 0).m_hs(9) - aasp(0, k) + aasp(1, k) / 2.0) Then
                                asp2(i, j) = (k + 1) * 2 + 1
                            ElseIf (planet(1, 0).m_hs(9) + aasp(0, k) - aasp(1, k) <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, 0).m_hs(9) + aasp(0, k) + aasp(1, k)) _
                                Or (planet(1, 0).m_hs(9) - aasp(0, k) - aasp(1, k) <= planet(0, i + 1).m_el) And (planet(0, i + 1).m_el <= planet(1, 0).m_hs(9) - aasp(0, k) + aasp(1, k)) Then
                                asp2(i, j) = (k + 1) * 2
                            End If
                        Next
                    End If
                ElseIf i = 18 Then
                    If j < 18 Then
                        For k = 0 To 9
                            If (planet(1, j + 1).m_el + aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, j + 1).m_el + aasp(0, k) + aasp(1, k) / 2.0) _
                                Or (planet(1, j + 1).m_el - aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, j + 1).m_el - aasp(0, k) + aasp(1, k) / 2.0) Then
                                asp2(i, j) = (k + 1) * 2 + 1
                            ElseIf (planet(1, j + 1).m_el + aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, j + 1).m_el + aasp(0, k) + aasp(1, k)) _
                                Or (planet(1, j + 1).m_el - aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, j + 1).m_el - aasp(0, k) + aasp(1, k)) Then
                                asp2(i, j) = (k + 1) * 2
                            End If
                        Next
                    ElseIf j = 18 Then
                        For k = 0 To 9
                            If (planet(1, 0).m_hs(0) + aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, 0).m_hs(0) + aasp(0, k) + aasp(1, k) / 2.0) _
                                Or (planet(1, 0).m_hs(0) - aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, 0).m_hs(0) - aasp(0, k) + aasp(1, k) / 2.0) Then
                                asp2(i, j) = (k + 1) * 2 + 1
                            ElseIf (planet(1, 0).m_hs(0) + aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, 0).m_hs(0) + aasp(0, k) + aasp(1, k)) _
                                Or (planet(1, 0).m_hs(0) - aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, 0).m_hs(0) - aasp(0, k) + aasp(1, k)) Then
                                asp2(i, j) = (k + 1) * 2
                            End If
                        Next
                    ElseIf j = 19 Then
                        For k = 0 To 9
                            If (planet(1, 0).m_hs(9) + aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, 0).m_hs(9) + aasp(0, k) + aasp(1, k) / 2.0) _
                                Or (planet(1, 0).m_hs(9) - aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, 0).m_hs(9) - aasp(0, k) + aasp(1, k) / 2.0) Then
                                asp2(i, j) = (k + 1) * 2 + 1
                            ElseIf (planet(1, 0).m_hs(9) + aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, 0).m_hs(9) + aasp(0, k) + aasp(1, k)) _
                                Or (planet(1, 0).m_hs(9) - aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(0)) And (planet(0, 0).m_hs(0) <= planet(1, 0).m_hs(9) - aasp(0, k) + aasp(1, k)) Then
                                asp2(i, j) = (k + 1) * 2
                            End If
                        Next
                    End If
                ElseIf i = 19 Then
                    If j < 18 Then
                        For k = 0 To 9
                            If (planet(1, j + 1).m_el + aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, j + 1).m_el + aasp(0, k) + aasp(1, k) / 2.0) _
                                Or (planet(1, j + 1).m_el - aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, j + 1).m_el - aasp(0, k) + aasp(1, k) / 2.0) Then
                                asp2(i, j) = (k + 1) * 2 + 1
                            ElseIf (planet(1, j + 1).m_el + aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, j + 1).m_el + aasp(0, k) + aasp(1, k)) _
                                Or (planet(1, j + 1).m_el - aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, j + 1).m_el - aasp(0, k) + aasp(1, k)) Then
                                asp2(i, j) = (k + 1) * 2
                            End If
                        Next
                    ElseIf j = 18 Then
                        For k = 0 To 9
                            If (planet(1, 0).m_hs(0) + aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, 0).m_hs(0) + aasp(0, k) + aasp(1, k) / 2.0) _
                                Or (planet(1, 0).m_hs(0) - aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, 0).m_hs(0) - aasp(0, k) + aasp(1, k) / 2.0) Then
                                asp2(i, j) = (k + 1) * 2 + 1
                            ElseIf (planet(1, 0).m_hs(0) + aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, 0).m_hs(0) + aasp(0, k) + aasp(1, k)) _
                                Or (planet(1, 0).m_hs(0) - aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, 0).m_hs(0) - aasp(0, k) + aasp(1, k)) Then
                                asp2(i, j) = (k + 1) * 2
                            End If
                        Next
                    ElseIf j = 19 Then
                        For k = 0 To 9
                            If (planet(1, 0).m_hs(9) + aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, 0).m_hs(9) + aasp(0, k) + aasp(1, k) / 2.0) _
                                Or (planet(1, 0).m_hs(9) - aasp(0, k) - aasp(1, k) / 2.0 <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, 0).m_hs(9) - aasp(0, k) + aasp(1, k) / 2.0) Then
                                asp2(i, j) = (k + 1) * 2 + 1
                            ElseIf (planet(1, 0).m_hs(9) + aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, 0).m_hs(9) + aasp(0, k) + aasp(1, k)) _
                                Or (planet(1, 0).m_hs(9) - aasp(0, k) - aasp(1, k) <= planet(0, 0).m_hs(9)) And (planet(0, 0).m_hs(9) <= planet(1, 0).m_hs(9) - aasp(0, k) + aasp(1, k)) Then
                                asp2(i, j) = (k + 1) * 2
                            End If
                        Next
                    End If
                End If
            Next
        Next
    End Sub

    '作成
    Private Sub Make(ByVal sw As Boolean)
        Dim f As Form2 = New Form2()
        'モーダル開き、戻り値を受け取る
        Dim result As DialogResult = f.ShowDialog()
        If result = DialogResult.OK Then
            '値を受け取る
            dat1 = f.GetDateTime1()
            longitude1 = f.GetLongitude1()
            dat2 = f.GetDateTime2()
            longitude2 = f.GetLongitude2()
            chart = f.GetChart()
        ElseIf result = DialogResult.No Then
            If sw = False Then
                f.Dispose()
                Return
            End If
        ElseIf result = DialogResult.Cancel Then
            If sw = False Then
                f.Dispose()
                Return
            End If
        End If
        f.Dispose()


        If chart Then
            PictureBoxHS.Size = New Size(541, 960)
        Else
            PictureBoxHS.Size = New Size(541, 1440)
        End If


        time = 0.0



        Dim dat0 As New DateTime(1996, 7, 1, 0, 0, 0)
        Dim ts As TimeSpan = dat1 - dat0
        Dim ddat As Double = ts.TotalDays
        Dim add As Double = (longitude1 Mod 180.0) / 360.0
        ddat = ddat - add

        ReDim planet(1, 32)


        PlanetInit(32, 0, dat1, add)

        Dim dat As Date = New Date(dat0.Year, dat0.Month, dat0.Day, dat0.Hour, dat0.Minute, dat0.Second)

        planet(0, 0).asc(dat.AddSeconds(ddat * 86400.0))
        planet(0, 0).house(planet(0, 0).m_asc)


        ts = dat2 - dat0
        ddat = ts.TotalDays
        add = (longitude2 Mod 180.0) / 360.0
        ddat = ddat - add

        PlanetInit(32, 1, dat2, add)


        dat = New Date(dat0.Year, dat0.Month, dat0.Day, dat0.Hour, dat0.Minute, dat0.Second)
        planet(1, 0).asc(dat.AddSeconds(ddat * 86400.0))
        planet(1, 0).house(planet(1, 0).m_asc)


        aspect()
        aspect2()

        DrawMount(chart)
    End Sub

    'フレーム更新
    Private Sub FrameMove()
        time = time + dt

        Dim dat0 As New DateTime(1996, 7, 1, 0, 0, 0)
        Dim ts As TimeSpan = dat1 - dat0
        Dim ddat As Double = ts.TotalDays
        Dim add As Double = (longitude1 Mod 180.0) / 360.0
        ddat = ddat - add + time / 86400.0
        Dim dat As New DateTime(dat1.Year, dat1.Month, dat1.Day, dat1.Hour, dat1.Minute, dat1.Second)
        dat = dat.AddSeconds(time)

        PlanetInit(32, 0, dat, add)

        planet(0, 0).asc(dat0.AddSeconds(ddat * 86400.0))
        planet(0, 0).house(planet(0, 0).m_asc)

        aspect()
        aspect2()

        DrawMount(chart)
    End Sub
End Class







